﻿using Infragistics.Documents.Excel;
using Infragistics.Documents.Excel.Charts;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ExcelChartDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Workbook workbook = Workbook.Load("../../CustomerWorkbook.xlsx");

            Worksheet worksheet = workbook.Worksheets[1] as Worksheet;
            Chartsheet chartSheet = workbook.Sheets.Add("ChartSheet1", SheetType.Chartsheet) as Chartsheet;

            int dataStartRow = 24;
            int dataEndRow = 624;
            int colIndex = 2;

            //WorksheetCell chartStartCell = worksheet.GetCell($"R{dataStartRow}C{colIndex + 3}", CellReferenceMode.R1C1);
            //WorksheetCell chartEndCell = worksheet.GetCell($"R{dataStartRow + 10}C{colIndex + 15}", CellReferenceMode.R1C1);

            //string chartStartAddress = chartStartCell.ToString();
            //string chartEndAddress = chartEndCell.ToString();

            //calculate the data range...
            //WorksheetChart chart = worksheet.Shapes.AddChart(ChartType.XYScatterLinesNoMarkers,
            //                                                 chartStartCell,
            //                                                 new Point(x: 0, y: 0),
            //                                                 chartEndCell,
            //                                                 new Point(x: 100, y: 100));

            //get the data cells figured out
            var xDataStart = worksheet.GetCell($"R{dataStartRow}C{colIndex}", CellReferenceMode.R1C1);
            //var xDataEnd = worksheet.GetCell($"R{dataEndRow}C{colIndex}", CellReferenceMode.R1C1)
            //                        .ToString()
            //                        .Split(separator: '!')[1];
            //var yDataStart = worksheet.GetCell($"R{dataStartRow}C{colIndex + 1}", CellReferenceMode.R1C1);
            var yDataEnd = worksheet.GetCell($"R{dataEndRow}C{colIndex + 1}", CellReferenceMode.R1C1)
                                    .ToString()
                                    .Split(separator: '!')[1];

            WorksheetChart chart = chartSheet.Chart;
            chart.ChartType = ChartType.XYScatterLinesNoMarkers;
            chart.SetSourceData($"{xDataStart}:{yDataEnd}");

            ChartLine line = new ChartLine()
            {
                Fill = new ChartSolidFill(new WorkbookColorInfo(System.Drawing.Color.Red))
            };

            chart.SeriesCollection[0].Line = line;

            var axes = chart.AxisCollection;

            var axis1 = axes[AxisType.Value];
            axis1.AxisTitle = new ChartTitle() { Text = new FormattedString("THIS IS THE Y AXIS")};
            axis1.Crosses = AxisCrosses.Minimum;                       

            axes.Remove(AxisType.Value, AxisGroup.Secondary);

            var axis2 = axes[AxisType.Category, AxisGroup.Primary];
            axis2.AxisTitle = new ChartTitle() { Text = new FormattedString("THIS IS THE X AXIS") };
            axis2.TickLabelSpacingIsAuto = false;            
            axis2.TickLabelSpacing = 100;
            axis2.TickMarkSpacing = 100;            
            
            
            if (File.Exists("file.xlsx"))
            {
                File.Delete("file.xlsx");
            }

            workbook.Save("file.xlsx");
            
            Process.Start("file.xlsx");
        }
    }
}
